#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_UseUpx=n
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#include <FileSystemMonitor.au3>
#include <Constants.au3>
#include <StaticConstants.au3>

If $CmdLine[0] = 0 Then
	MsgBox(64,'ncfet2p', 'Command: ncfet2p.exe <dir>' & @CRLF & @CRLF & 'Where: <dir> = Directory to watch for TIF')
	Exit
Else
	$path = $CmdLine[1]
	If StringRight($path, 1) = '\' Then $path = StringMid($path, 1, StringLen($path) - 1)
	If FileExists($path) = 0 Then
		MsgBox(48, 'ncfet2p', 'Error: Path does not exist!')
		Exit
	EndIf
EndIf

Global $tempFile = '', $path

; Setup File System Monitoring
_FileSysMonSetup(3, $path, "")

; Main Loop

While 1

	; Handle Directory related events
	_FileSysMonDirEventHandler()

WEnd

Func _FileSysMonActionEvent($event_type, $event_id, $event_value)
	Local $event_type_name
	Local $fs_event = ObjCreate("Scripting.Dictionary")

	if Hex($event_id) > 0 Then

; If event = 'file added' then save filename
		If $event_id = 1 Then
			$tempFile = $event_value
		EndIf

; If event = 'drive space change' then call nconvert routine with full path\filename
		If $event_id = '0x00040000' And $tempFile <> '' Then
			ncon($path & '\' & $tempFile)
			$tempFile = ''
		EndIf
	EndIf
EndFunc

Func ncon($file)
	If StringUpper(StringMid($file, StringInStr($file, '.', 0, -1), 4)) <> '.TIF' Then Return

	$newfile = StringMid($file, 1, StringInStr($file, '.', 0, -1)) & 'pdf'
	If StringInStr($file, ' ') > 0 Then
		$file = '"' & $file & '"'
		$newfile = '"' & $newfile & '"'
	EndIf

; nconvert parameters: no output, multipage, ZIP compression, PDF output
	$nconcmd = 'nconvert.exe -quiet -multi -c 4 -out pdf -o ' & $newfile & ' ' & $file

	TrayTip('ncfet2p', 'Converting: ' & $file, 2, 1)
	Local $foo = Run(@comspec & ' /c ' & $nconcmd, '.', @SW_HIDE, $STDOUT_CHILD + $STDERR_CHILD)
	If @error Then
		MsgBox(0, 'Error', 'Failed to run nconvert.exe')
	EndIf
	$output = ''
	While 1
		$output &= StdoutRead($foo)
		If @error <> 0 Then ExitLoop
	WEnd
	$output = ''
	While 1
		$output &= StderrRead($foo)
		If @error <> 0 Then ExitLoop
		If @extended > 0 Then MsgBox(0, "STDERR read:", 'Error from nconvert command:' & @CRLF & @CRLF & $output & @CRLF & 'Error code: ' & @error)
	WEnd
EndFunc